明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1636|回复: 2

[求助]属性块文字的居中对齐

[复制链接]
发表于 2007-6-2 14:02:00 | 显示全部楼层 |阅读模式

请问一下,怎样实现属性块中文字的居中对齐?

我之前找了一个,但好像实现不了,有这方面的源码的发一下好吗?

谢谢了!!!

发表于 2007-6-2 23:18:00 | 显示全部楼层
  1. (setq alatt_al "M") ;控制对齐方式的全局变量
  2. (defun alatt (/ ss ent na tmp al e72 e66 attent n att attpt)
  3.   (initget "L R M ")
  4.   (if (setq tmp
  5.       (getkword
  6.         (strcat "\n请选择对齐方式[左(L)/中(M)/右(R)]<" alatt_al ">")
  7.       )
  8.       )
  9.     (setq alatt_al tmp)
  10.   ) ;_IF
  11.   (cond ((= alatt_al "L") (setq e72 0))
  12. ((= alatt_al "M") (setq e72 1))
  13. ((= alatt_al "R") (setq e72 2))
  14.   ) ;将对齐方式转换成对齐的组码值
  15.   (setq ss (ssget '((0 . "INSERT"))))
  16.   (if ss
  17.     (progn
  18.       (setq n 0)
  19.       (repeat (sslength ss)
  20. (setq na  (ssname ss n)
  21.        att na
  22.        ent (entget na)
  23.        n   (1+ n)
  24. )
  25. (if (and (setq e66 (assoc 66 ent)) (= (cdr e66) 1)) ;判断是否为属性块
  26.    (while
  27.      (and
  28.        (setq att (entnext att))
  29.        (/= (cdr (assoc 0 (setq attent (entget att)))) "SEQEND")
  30.      )
  31.       (setq attpt (alatt-startPt attent)) ;获得文字的插入点
  32.       (setq attent (subst (cons 10 attpt) (assoc 10 attent) attent)
  33.      attent (subst (cons 11 attpt) (assoc 11 attent) attent)
  34.       )
  35.       (if (assoc 72 attent)
  36.         (setq attent (subst (cons 72 e72) (assoc 72 attent) attent)
  37.         )
  38.         (setq attent (REVERSE attent)
  39.        attent (cons (cons 72 e72) attent)
  40.        attent (REVERSE attent)
  41.         )
  42.       )
  43.       (entmod attent)
  44.       (entupd na)
  45.    ) ;遍历属性块的属性图元,进行对齐操作
  46. ) ;_IF
  47.       ) ;_REPEAT
  48.     )
  49.   ) ;_IF
  50.   (princ)
  51. ) ;_END_DEFUN
  52. ;;;判断当前文字的对齐方式,返回文字的插入点
  53. (defun alatt-startPt (ent / rel e72 e74)
  54.   (setq e72 (assoc 72 ent)
  55. e74 (assoc 74 ent)
  56.   )
  57.   (if (or (and e72 (/= (cdr e72) 0))
  58.    (and e74 (/= (cdr e74) 0))
  59.       )
  60.     (setq rel (cdr (assoc 11 ent)))
  61.     (setq rel (cdr (assoc 10 ent)))
  62.   )
  63.   rel
  64. )
回复 支持 1 反对 0

使用道具 举报

发表于 2024-11-11 21:56:52 | 显示全部楼层
确实有用,好东西谢谢了。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-21 01:32 , Processed in 0.203361 second(s), 26 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表